#include "pic32_c.h"
#include "debug.h"

/* Value output functions. */

void bits(uint32_t reg)
{
    vbits(REG(reg));
}

void vbits(uint32_t val)
{
    uint32_t mask;

    for (mask = (1 << 31); mask; mask >>= 1)
        if (val & mask)
            uart_write('1');
        else
            uart_write('0');

    uart_write('\r');
    uart_write('\n');
}

void vhex(uint32_t val)
{
    uint32_t mask;
    uint8_t digit, shift;

    for (mask = (0b1111 << 28), shift = 28; mask; mask >>= 4, shift -= 4)
    {
        digit = (val & mask) >> shift;
        if (digit > 9)
            uart_write('A' + digit - 10);
        else
            uart_write('0' + digit);
    }

    uart_write('\r');
    uart_write('\n');
}

/* General output functions. */

void uart_write(char c)
{
    while (REG(UART_REG(1, UxSTA)) & (1 << 9)); /* UTXBF (buffer full) */

    REG(UART_REG(1, UxTXREG)) = c;
}

void uart_write_string(const char *s)
{
    while (*s)
        uart_write(*s++);
}
